;       ******    EJEMPLO DE PROGRAMACION  ******
;       ******    MICROPROCESADOR M-68000    ******
;
;
        ABSOLUTE
	ORG  $25000
	MOVE.L #$27000,A7	;Inicializacin del stack pointer
	MOVE.L #$26000,A3
	CLR D7			;Borrado del registro contador
        PEA START		;Mensaje de entrada de caracteres
	MOVE.L #25,D0
	TRAP #0
	ADDQ.L #4,SP
PRIM:	MOVE.L #23,D0		;Bucle de entrada de datos
	TRAP #0
	MOVE.B D0,D2
	MOVE.L D0,-(A7)		
	MOVE.L #24,D0		;Devolver el dato a pantalla
	TRAP #0
	ADDQ.L #4,A7
	MOVE.B D2,D0
	CMPI.B #$0D,D2		;Salir del bucle si se entr un carcter 
	BEQ ORDEN		;de carry return
	MOVE.B D2,(A3)+		;Salvar dato a memoria
	ADDI #1,D7
	JMP PRIM		;Si no, seguir en el bucle
ORDEN:  PEA LINEA		;Salto de lnea
	MOVE.L #25,D0
	TRAP #0
	ADDQ.L #4,SP

;                  ALGORITMO DE ORDENACION POR BURBUJA
;       FOR J=1 TO N-1
;           FOR I=1 TO N-J
;               IF ELEMENTO(TABLA-1+I)>ELEMENTO(TABLA+I) THEN
;                  TEMP=ELEMENTO(TABLA-1+I)
;                  ELEMENTO(TABLA-1+I)=ELEMENTO(TABLA+I)
;                  ELEMENTO(TABLA+I)=TEMP
;           NEXT I
;       NEXT J
;       (EL PRIMER ELEMENTO A ORDENAR ESTA EN LA POSICION TABLA) 
  
        CLR.L D2        ;puesta a cero de D2 
        MOVE.L D2,D3    ;puesta a cero de D3
        MOVE.B D2,(A3)  
	MOVE.L D7,D5
	SUB.L #1,D5	;D5=N-1
	MOVE.L #1,D0	;J=1 (inicializar)
EXT:	MOVE.L #1,D1	;I=1 (inicializar)
	MOVE.L D7,D6
	SUB.L D0,D6	;D6=N-J
INT:	MOVE.L #$25FFF,A2
	ADD.L D1,A2	;A2=$26000-1+I
	MOVE.L A2,A3
	ADDA.L #1,A3	;A3=$26000+I
	MOVE.B (A2),D2	;D2=($26000-1+I)
	MOVE.B (A3),D3	;D3=($26000+I)
	CMP D2,D3
	BLE INCI	;si ($26000-1+I)<=($26000+I) entonces
                        ;salta a INCI sino continua
	MOVE.B (A2),D4
	MOVE.B (A3),(A2)
	MOVE.B D4,(A3)	;cambio de orden (D4 es variable auxiliar)
INCI:	CMP D1,D6
	BEQ INCE	;si I=N-J entonces salta a INCI sino continua
	ADD #1,D1	;I=I+1
	JMP INT		;vuelta al bucle interno
INCE:	CMP D0,D5
	BEQ FINAL	;si J=N-1 entonces se acaba la ordenacion 
                        ;sino continua
	ADD #1,D0	;J=J+1
	JMP EXT		;vuelta al bucle externo
;
;       CALCULO DEL NUMERO DE CARACTERES (ASCII) ORDENADOS 
;
FINAL:	MOVE.L #5,D0		;Contador del bucle
	MOVE.L #$25141,A1	;Posicin en la cadena de caracteres
	MOVE.L D7,D6		;Salvar inicialmente
OTRO:	MOVE.L D6,D7		;Recuperar valor a estudiar
	DIVU #$A,D7		;Divisin por 10 (decimal)
	MOVE.W D7,D6		;Salvar el cociente (solo el cociente)
	SWAP D7			;Alterar orden en D7
	AND.L #$FFFF,D7		;Tomar slo el resto
        ADD #$30,D7		;Sumar 30 (hexa) para tener cdigo ASCII
	MOVE.B D7,-(A1)		;Mover a memoria (con predecremento)
	SUB #$1,D0		;Decrementar el contador
        BGT OTRO		;Seguir el bucle hasta finalizar
;
;       SALIDA DE CARACTERES ORDENADOS POR PANTALLA
;
	PEA OUT			;Mensaje de salida de caracteres
	MOVE.L #25,D0
	TRAP #0
	ADDQ.L #4,SP
        PEA $26000		;Salida de caracteres ordenados
	MOVE.L #25,D0
	TRAP #0
	ADDQ.L #4,SP
	TRAP #5
;
;       TABLAS DE MENSAJES POR PANTALLA
;
START:  DB 'Introduzca los caracteres a ordenar:'
        DB 10,13,0
OUT:    DB 'Se han ordenado 00000 caracteres. Su tabla ordenada es:'
        DB 10,13,0
LINEA:  DB 10,13,0
	END
